
/*
ͻ
                       OoClip   Version 1.5                           
             An Object Oriented Extension to Clipper 5.2X             
             OoClip  (c) 1996,1997 Nixil Hsiao, Universeen            
             o:Clip  (c) 1991 Peter M. Freese, CyberSoft              
ͼ

 Demostrates ALIAS statement usage

*/


#include "ooclip.ch"

PROC main

  LOCAL o2 := Sample2():New("World")
  o2:Hello()
  o2:ClassInfo()
  ? "Class Handle:", o2:ClassHandle()

RETURN

CLASS Sample1 ALIAS S1
  VAR Who
  METHOD New , Hello, Work
ENDCLASS

/* Above definition is same as following:
CLASS Sample1 ALIAS S1
  VAR Who
  METHOD New  = S1New
  METHOD Hello= S1Hello
  METHOD Work = S1Work
ENDCLASS
*/

METHOD FUNCTION S1New(cWho)
  ::Who := cWho
RETURN Self

METHOD FUNCTION S1Hello
  ? "Here, Run Sample1:Hello(), Sample1:Who=",::Who
  ? "------- Then Call ::Work() ---->  // oClip & o:Clip is different "
  ? ::Work()
  ? "                                  // As you see, OoClip Call Sample2:Work()"
  ? "                                  //       While o:Clip Call Sample1:Work()"
RETURN Self

METHOD FUNCTION S1Work
  ? "Here Run Sample1:Work()"
RETURN Self


CLASS Sample2 ALIAS S2 FROM Sample1
  METHOD Work
ENDCLASS

METHOD FUNCTION S2Work
  ? "Here, Run Sample2:Work()"
RETURN Self


