/*
ͻ
                   Demo for  ooclip  1.5                              
             An Object Oriented Extension to Clipper 5.2              
                 (c) 1996 Nixil Hsiao, Universeen Co., Ltd.           
                 (c) 1991 Peter M. Freese, CyberSoft                  
ͼ

This file shows Usage of TBrowse Class and TBColumn Class

By Nixil Hsiao (uniseen@public3.bta.net.cn)

*/

#include "ooclip.ch"
FUNCTION  Main(cFile)
    LOCAL kp_area:=SELECT(), i, oB
    SELECT 0
    IF  cFile==NIL
        ?
        ? "Usage: TBDEMO  DbfFile"
        ?
        ? "By Nixil Hsiao, 1996/03"
    ELSEIF FILE(cFile)
        USE (cFile)
        oB:=TBrowse():New(0,0,24,79)
        // oB:=DBrowse():New(0,0,24,79,TB_NOAPPEND)   // for autoMIS
        FOR i:=1 TO FCOUNT()
            oB:AddColumn(TBColumn():New(FIELDNAME(i),FIELDBLOCK(FIELDNAME(i)) ))
        NEXT
        oB:Exec()    // Here Get():New() will be called
        USE
    ENDIF
    SELECT (kp_area)
RETURN NIL

/*

// Following Demo work with autoMIS

CLASS DBrowse ALIAS DBrow FROM TBrowse
    VAR oWin
    METHOD New,Exec
ENDCLASS

METHOD FUNCTION DBrowNew(t,l,b,r,nMode)
    REQUEST INITEXIT
    ::oWin:=Window():New(t,l,b,r,,,.F.)
    ::TBNew(t+1,l+2,b-1,r-2,nMode)
RETURN Self

METHOD FUNCTION  DBrowExec()
    ::oWin:Open()
    ::TBExec()
    ::oWin:Close()
RETURN Self

*/
